/*
 *
 * Author  : Ali ERDEM
 * Start Dt: December 10, 1992
 * Modified: January   4, 1993 by Santosh Rao
 * Purpose : Compatibility functions for CM-5 CMMD library
 */


#include <comm.h>
#include <CMMDlib.h>


void
CMMD_send_and_receive_v(source,tag_in, in_start, in_size, in_stride, in_count, 
			dest,  tag_out,out_start,out_size,out_stride,out_count)

int source, tag_in, in_size, dest, tag_out, out_size, in_stride, in_count, 
    out_stride,out_count;
char *in_start, *out_start;
{
  int my_id;
  
  my_id = gettid();
  if (source < my_id) {
    CMMD_send_v(dest,tag_out,out_start,out_size,out_stride,out_count);
    CMMD_receive_v(source,tag_in,in_start,in_size,in_stride,in_count);
  } 
  else {
    CMMD_receive_v(source,tag_in,in_start,in_size,in_stride,in_count);
    CMMD_send_v(dest,tag_out,out_start,out_size,out_stride,out_count);
  }
}


CMMD_msg_err(s1, s2, s3)
char *s1, *s2, *s3;
{
  io_printf(s1, s2, s3);
}
