/*
 * Copyright (c) 1992, 1993 by the University of Southern California
 *
 * For copying and distribution information, please see the files
 * <prm-copyr.h>.
 * 
 * Written by srao 7/92
 *
 */

#include <prm-copyr.h>

#include <ardp.h>

#include <sys/socket.h>
#include <netdb.h>

#include <pmachine.h>
#include <pprot.h>
#include <perrno.h>
#include <prm.h>


/* Wildcard task and tag. The receiver task specifies ANY_TASK to match 
   a message from any sender and/or ANY_TAG to ignore the tag value  in
   retrieving a message  */ 

#define ANY_TASK -1
#define ANY_TAG  -1


#define RNEIGH(x,tot)    (x<tot)?x+1:1
  
struct tasklist {
  u_long tid;
  PRM_node_addr_t host_addrp;   /* internet address of host */
  u_short nports;
  u_short *ports;         
};


/* Functions defined in the ARDP and  communication libraries */

extern int    vsend();
extern int    vrecv();
extern int    numtasks();
extern void   sendrecv();
extern RREQ   get_message(); 

extern PRM_node_addr_t get_dest_addr();

struct cache {
  u_short tag;
  struct tasklist *tinfo;
};

#ifdef MAIN_PROG
PTEXT msg_buf;

u_long tag = 0;

struct cache *trsln_cache;

char _jm_hostname[MAXHOSTNAMELEN]; /*  Name of host on which the jobmngr of 
				       this task is running */
char _my_hostname[MAXHOSTNAMELEN]; /*  Name of host on which this process is
				       running */

PRM_node_addr_t _jm_host_addr, _fio_host_addr, _tio_host_addr;

char *_progname;                   /*  Name of file containing executables */
char  errlog[64];                  /*  File for logging errors */

u_long _my_jobid;                  /*  Job identifier. Used only by tasks */
u_long _my_taskid;                 /*  Task identifier. A small integer, 
				       unique for each task within a job */
u_short _my_portnum;               /*  UDP Port number of internet socket */

u_long _ntasks=0;                  /*  Total number of tasks */
int prm_debug = 0;
int perrno, pfs_debug, pdap_errno;

int initdone = FALSE;

int app_debug_lev;

char    p_err_string[P_ERR_STRING_SZ];

#else

extern
PTEXT msg_buf;

extern
u_long tag;

extern
struct cache *trsln_cache;

extern
char _jm_hostname[];        /*  Name of host on which the jobmngr of 
				this task is running */
extern
char _my_hostname[];        /*  Name of host on which this process is
				running */

extern
PRM_node_addr_t _jm_host_addr , _fio_host_addr, _tio_host_addr;

extern
char *_progname;                   /*  Name of file containing executables */
extern
char  errlog[64];                  /*  File for logging errors */


extern
u_long _my_jobid;                  /*  Job identifier. Used only by tasks */
extern
u_long _my_taskid;                 /*  Task identifier. A small integer, 
				       unique for each task within a job */
extern
u_short _my_portnum;

extern
u_long _ntasks;                    /*  Total number of tasks */
extern
int prm_debug;
extern
int perrno, pfs_debug, pdap_errno;

extern
int initdone;

extern
int app_debug_lev;

#endif

