/*
 * Copyright (c) 1992, 1993 by the University of Southern California
 *
 * For copying and distribution information, please see the files
 * <prm-copyr.h>.
 *
 * Modified by srao 6/92 - 9/92
 *
 */

#include <prm-copyr.h>


#include <prm.h>

#ifndef DFL_SM
#   define DFL_SM "atg.isi.edu"
#endif

#define FIRST_USR_PORT 43250
#define TIMER_INTERVAL 60    /* Default value for the timer, on whose expiry,
				the availability status of node is checked */

/* interval between checks for users, when the workstation is idle and
   when a user is logged on */

#define UNUSED_CHK_INTVL 60
#define USER_ON_CHK_INTVL 900

#define UT_SET    0x0001  /* Activate utmp checking for this run */
#define TM_ENBL   0x0002  /* Enable the timer alarm */
#define DIS_TMP   0x0004  /* Timer temporarily disabled to fork child process*/


#ifndef LOC_BIN_DIR
#  define LOC_BIN_DIR "/nfs/pfs/divirs/jmsm/new/bin"
#endif

#define min(x,y) ((x<y)? x:y)


struct taskinfo {
  u_long tid;
  PRM_node_addr hostaddr;      /* address of task's node */
  short status;      
  u_short nports;              /* Number of comm. ports for this task */
  u_short *ports;              /* Array containing port numbers */
  struct pidlist *pid_tbl_p;   /* Pointer into the nodemngr-maintained process
				  table for the tasks */
  struct timeval start_time;  /* Real time at which task started execution */
  struct taskinfo *next;  
};


struct job_info {
  u_long jid;
  int numtasks;
  struct taskinfo *taskptr;
  PRM_node_addr jmaddr;     /* addr of jobmngr's node */
  PRM_node_addr iotaddr;    /* addr of term-iotask's node  */
  PRM_node_addr fioaddr;    /* addr of file-iotask's node  */
  char   *cache_tag;        /* Tag bits to indicate whether info about a
				 task has been cached */
  struct job_info *next,
                  *previous;
};

typedef struct job_info *JINF;


struct pidlist {
  int pid;                   /* Unix process-id of task */
  struct taskinfo *taskptr;  /* Pointer to task-info in job table */
  JINF      jobptr;          /* Pointer to job_info  in job table */
  struct pidlist *next,
                 *previous;  
};

struct authlist {
  u_long jid;
  u_long acode;                 /* Authorization code given by sysmngr */
  PRM_node_addr addr;   /* Address of host to whom above code applies */
  struct authlist *next,
                  *previous;
};


