/*
 * Copyright (c) 1992, 1993 by the University of Southern California
 *
 * For copying and distribution information, please see the files
 * <prm-copyr.h>.
 *
 * Written by srao 8/92
 *
 */

#include <prm-copyr.h>

#include <stdio.h>

#include <comm.h>

#include <errno.h>

#if defined(HPUX)
#   include <unistd.h>   
#endif

extern char *sys_errlist[];


/* create socket and bind a name to it. */

create_srv_socket(lpnum, tid)
u_char lpnum;
u_long tid;
{
  PTEXT pkt, rpkt;
  RREQ newreq;
  int ntd, ntmp1;      
  char buf[64];
  struct sockaddr_in *dest;
  u_short port_num;
  char *msg;
  
  if (gethostname(_my_hostname, MAXHOSTNAMELEN) == -1) {
    sprintf(p_err_string, "gethostname: %s", sys_errlist[errno]);
    return ERRORCODE;
  }
  
  do {             /* Get an unassigned udp-port number from nodemngr */
    
    newreq = ardp_rqalloc();
    pkt = newreq->outpkt = ardp_ptalloc();
    msg = pkt->start;
    *(msg + PRM_OP_OFFSET) = (u_char)PBINDREQ;
    *(msg + PNUMOFFSET) = lpnum;
    
    ntmp1 = htonl(_my_jobid);
    bcopy(&ntmp1, msg + PRM_JIDOFFSET, LONG_SZ);
    ntmp1 = htonl(tid);
    bcopy(&ntmp1, msg + NTOFFSET, LONG_SZ);
    pkt->length = NTOFFSET + LONG_SZ;
    
    ardp_send(newreq, _my_hostname, 0, -1);
    
    if( (rpkt = newreq->rcvd) ) 
      msg = rpkt->start;
    else
      fprintf(stderr, "%s (Task %d) nodemngr on %s not responding\n",
	      _progname, _my_taskid, _my_hostname);
    
    ardp_rqfree(newreq);
    
  } while ((rpkt == NULL) || ( *(msg + SCODEOFFSET) != SUCCESS) );
  
  bcopy(msg + SMSGOFFSET, &port_num , 2);
  port_num = ntohs(port_num);
  sprintf(buf,"#%d", port_num);
  port_num = ardp_bind_port(buf);
  return port_num;
}

