/*
 * Copyright (c) 1993 by the University of Southern California
 *
 * For copying and distribution information, please see the files
 * <prm-copyr.h>.
 *
 * Written by srao 2/93
 *
 */

#include <prm-copyr.h>

#include <comm.h>

#include <errno.h>

#if defined(HPUX)
#   include <unistd.h>   
#endif

extern char *sys_errlist[];

read_file_into_pkts(req, fpath, fd, tot_len)
int fd, tot_len;
char *fpath;
RREQ req;
{
  PTEXT pkt_i;
  int last_pdata_len, tot_pkts, pkt_num, read_len, copied_len=0;
  u_long nlen;

  last_pdata_len = tot_len % PRM_APPL_MSG_LEN ;
  tot_pkts = tot_len/PRM_APPL_MSG_LEN + (last_pdata_len > 0);
  
  for (pkt_num = 1; pkt_num <= tot_pkts; pkt_num++) {
    int this_pkt_dat_len = ((pkt_num == tot_pkts)? last_pdata_len: 
			    PRM_APPL_MSG_LEN);
    
    pkt_i = ardp_ptalloc();
    read_len = read(fd, pkt_i->start + PRM_APPL_MSG_OFFSET, this_pkt_dat_len);
    if (read_len == -1) {
      if (pkt_num > 1) {  /* Some pkts already filled. This is not the first */
	ardp_ptfree(pkt_i);
	break;
      }
      else {
	sprintf(p_err_string, "Could not read %s: %s", fpath, 
		sys_errlist[errno]);
	return ERRORCODE;
      }
    }
    APPEND_ITEM(pkt_i, req->outpkt); 
    if (read_len == 0) {
      pkt_i->length = PRM_APPL_MSG_OFFSET + this_pkt_dat_len;
      copied_len += this_pkt_dat_len;
      break;
    }
    else {
      pkt_i->length = PRM_APPL_MSG_OFFSET + read_len;
      copied_len += read_len;
    }    
  }
  return copied_len;
}

