/*
 * Copyright (c) 1993 by the University of Southern California
 *
 * For copying and distribution information, please see the files
 * <prm-copyr.h>.
 *
 * Written by srao 3/93
 *
 */

#include <prm-copyr.h>

#include <sys/stat.h>
#include <comm.h>
#include <pdap.h>

#if defined(HPUX)
#   include <unistd.h>   
#endif

extern PRM_node_addr_t get_dest_addr();


io_stat(fname, buf)
char *fname;
struct stat *buf;
{
  RREQ req;
  PTEXT pkt, rpkt;
  char *msg;
  u_long length, flen, pdap_datalen;

  if (buf == NULL) {
    strcpy(p_err_string, ": Null buffer supplied.");
    return -1;
  }

  if (_fio_host_addr == NULL)
    _fio_host_addr = get_dest_addr(0, 2);
  
  flen = strlen(fname) + 1;
  pdap_datalen = flen + 1;

  req = ardp_rqalloc();
  pkt = req->outpkt = ardp_ptalloc();
  msg = pkt->start;
  
  *msg = (char)PDAP_VERSION; ++msg;
  *msg = (char)PDAP_STAT; ++msg;
  ENCODE_ASN1_LENGTH(msg,pdap_datalen);
  *msg = PDAP_FS; ++msg;
  bcopy(fname, msg, flen); msg += flen;
  ENCODE_ASN1_LENGTH(msg,_my_taskid);
  pkt->length = msg - pkt->start;
  
  if ((perrno = ardp_send(req, 0, _fio_host_addr, -1)) != ARDP_SUCCESS) {
    pdap_errno = PDAP_ARDP_ERR;
    sprintf(p_err_string, "ardp_send returned %d", perrno);
    return -1;
  }

  if( (rpkt = req->rcvd) == NOPKT) {
    strcpy(p_err_string, "No response from File-IO task " );
    return -1;
  }
  
  msg = rpkt->start;
  if (*msg == PDAP_VERSION) {
    if (*(++msg) != PDAP_STAT_RESP) {
      pdap_errno = PDAP_WRONG_RESP;
      strcpy(p_err_string, "Unexpected response code");
      return -1;
    }
    ++msg;
    DECODE_ASN1_LENGTH(msg,length);
    if ( *msg == PDAP_SUCCESS) {
      bcopy(msg + 1, buf, sizeof(struct stat));
      return SUCCESS;
    }
    else {
      if (length > 1) {
	pdap_errno = (int)*(msg+2);
	bcopy(msg + 3, p_err_string, length - 2);
      }
      else
	pdap_errno = PDAP_UNKNOWN;
      return -1;
    }
  }
  pdap_errno = PDAP_WRONG_VERSION;
  strcpy(p_err_string, "Wrong PDAP version");
  return -1;
}
