/*
 * Copyright (c) 1992, 1993 by the University of Southern California
 *
 * For copying and distribution information, please see the files
 * <prm-copyr.h>.
 *
 * Written by srao 7/92
 *
 */

#include <prm-copyr.h>


#include <stdio.h>

#include <comm.h>


int
  numtasks()
{
  PTEXT pkt, rpkt;
  RREQ newreq;
  char *msg;
  u_long ntmp1;
  int rval;
  
  if (_ntasks) return _ntasks;

  if ( _my_hostname[0] == '\0' ) {
    gethostname(_my_hostname, MAXHOSTNAMELEN);
  }
 again:
  
  pkt = ardp_ptalloc();
  msg =  pkt->start;
  *(msg + PRM_OP_OFFSET) = (u_char) TASKCOUNT;
  
  ntmp1 = htonl(_my_jobid);
  bcopy(&ntmp1, msg + PRM_JIDOFFSET, LONG_SZ);
  pkt->length = NTOFFSET + LONG_SZ;
  
  newreq = ardp_rqalloc();
  newreq->outpkt = pkt;
  ardp_send(newreq, _my_hostname, 0, -1);

  if( (rpkt = newreq->rcvd) == NOPKT) {
    fprintf(stderr,"%s (jobid=%lu taskid=%d) Task-count request to nodemngr %s timed out!\n", _progname, _my_jobid, _my_taskid, _my_hostname);
    sleep(3); 
    goto again;

  }
  msg = rpkt->start;
  if ( (*(msg + REPOFFSET)== TASKCOUNT) && (*(msg + SCODEOFFSET) == SUCCESS)) {
    bcopy(msg + SMSGOFFSET, &ntmp1, LONG_SZ);
    _ntasks = ntmp1 = ntohl(ntmp1);
    rval = _ntasks;
  }
  else {
    if(prm_debug)
      fprintf(stderr, "(task %d) Nodemngr could not provide task count!\n", 
	      _my_taskid);
    rval = ERRORCODE;
  }
  ardp_rqfree(newreq);
  return rval;
}
