/*
 * Copyright (c) 1993 by the University of Southern California
 *
 * For copying and distribution information, please see the files
 * <prm-copyr.h>.
 *
 * Written by srao 1/93
 *
 */

#include <prm-copyr.h>

#include <comm.h>


int
prm_server_respond(RREQ req, u_char op, u_char status, int info, 
		   char *emsg_buf)
{
  
  u_short emsglen, nelen;
  PTEXT rpkt;
  int ninfo;

  if (req->outpkt)
    ardp_ptlfree(req->outpkt);

  rpkt = req->outpkt = ardp_ptalloc();
  *(rpkt->start + PRM_OP_OFFSET) = op;
  *(rpkt->start + SCODEOFFSET) = status;
  rpkt->length = SCODEOFFSET + 1;
  ninfo = htonl(info);
  bcopy(&ninfo, rpkt->start +PRM_JIDOFFSET, 4);

  if (status == FAILURE) {
    emsglen = strlen(emsg_buf) + 1;
    if (emsglen > 1) {
      nelen  = htons(emsglen);
      bcopy(&nelen, rpkt->start + ERRMSGOFFSET, 2);
      bcopy(emsg_buf, rpkt->start + ERRMSGOFFSET + 2, emsglen);
      rpkt->length = ERRMSGOFFSET + 2 + emsglen;
    }
  }
  return(ardp_respond(req, ARDP_R_COMPLETE));

}

