/*
 * Copyright (c) 1993 by the University of Southern California
 *
 * For copying and distribution information, please see the files
 * <prm-copyr.h>.
 *
 * Written by srao 1/93
 *
 */

#include <prm-copyr.h>


#include <stdio.h>
#include <ardp.h>

#include <sys/socket.h>
#include <signal.h>       /* To handle signals from child tasks, timers */
#include <sys/wait.h>     /* To obtain exit status of child */
#include <utmp.h>
#include <netdb.h>

#include <nodemngr.h>

#include <comm.h>

get_l2p_from_remote(u_char portid, u_long jid, u_long tid, 
		    PRM_node_addr_t addrp)
{
  
  PTEXT pkt, rpkt;
  RREQ  newreq;
  char *msg;
  u_long ntmp1;
  
  /*  get l->p mapping from the remote nodemngr */

  pkt = ardp_ptalloc();  /* FILL THIS UP */
  msg =  pkt->start;
  *(msg + PRM_OP_OFFSET) = (tid ? (u_char)PMAP_REQ : (u_char) IJADD_REQ);
  *(msg + PNUMOFFSET) = portid;
  
  ntmp1 = htonl(jid);
  bcopy(&ntmp1, msg + PRM_JIDOFFSET, LONG_SZ);
  ntmp1 = htonl(tid);
  bcopy(&ntmp1, msg + NTOFFSET, LONG_SZ);
  pkt->length = NTOFFSET + LONG_SZ;
  addrp->sin_port = htons((u_short)NODEMNGR_PORT);
  
  newreq = ardp_rqalloc();
  newreq->outpkt = pkt;
  ardp_send (newreq, 0, addrp, -1);
  rpkt = newreq->rcvd;
  
  if (rpkt == NOPKT) {
    addrp->sin_port = 0;
    fprintf (stderr, "(%s %s) remote nodemngr on %s did not respond!\n", 
	     _progname, _my_hostname, inet_ntoa(addrp->sin_addr) );
  } 
  else {
    msg = rpkt->start;
    if (*(msg + SCODEOFFSET) == SUCCESS) { /* got port
					      & addr */
      bcopy(msg + SMSGOFFSET, addrp, PRM_AD_SZ);
      addrp->sin_family = AF_INET;
    }
    else
      addrp->sin_port = 0;
  } 
  ardp_rqfree(newreq);
  if (addrp->sin_port)
    return SUCCESS;
  else
    return ERRORCODE;
} 
