/******************************  pmrandom.h  ***************************

  Purpose:	External declarations for random-number generator
  		package used by this program.

  Provenance:	Written and tested by Q. Chen and E. Fox, March 1991.
  		Edited by S. Wartik, April 1991.

  Notes:	The implementation is better than the random number
  		generator from the C library.  It is taken from Park and
		Miller's paper, "Random Number Generators: Good Ones are
		Hard to Find," in CACM 31 (1988), pp. 1192-1201.
**/

#ifdef __STDC__
extern void	setseed(int);	/* Set the seed to a specified value.	   */
extern int	pmrandom();	/* Get next random number in the sequence. */
extern int	getseed();	/* Get the current value of the seed.	   */
#else
extern void	setseed();
extern int	pmrandom();
extern int	getseed();
#endif

#define	DEFAULT_SEED	23
