/******************************  rantab.h  **********************************

  Purpose:	External definitions for the three random number tables.

  Provenance:	Written and tested by Q. Chen and E. Fox, March 1991.
  		Edited and tested by S. Wartik, April 1991.

**/

#define NO_TABLES 3	/* Number of random number tables.	*/
#define ROWS 128	/* Rows of the random table (suitable for char). */
#define COLUMNS 150	/* Columns of the random table.		*/

typedef int randomTablesType[NO_TABLES][ROWS][COLUMNS]; /* random number table */

#ifdef __STDC__

extern void	initialize_randomTable( randomTablesType tables, int *seed );

#else

extern void	initialize_randomTable();

#endif
