
/********************************   stop.h   *********************************

    Purpose: Stop list DFA generator and driver module header.

    Notes:   This module implements a fast finite state machine generator,
             and a driver, for implementing stop list filters.
**/

#ifndef STOP_H
#define STOP_H

#include "strlist.h"               /* this code relies on the StrList package */

/******************************************************************************/
/******************************   Public Types   ******************************/

typedef struct _DfaStruct *DFA;      /* Deterministic Finite Automaton object */

/******************************************************************************/
/****************************   Public Routines   *****************************/

#ifdef __STDC__

extern DFA   BuildDFA( StrList words );
extern char *GetTerm( FILE *stream, DFA machine, int size, char *output );

#else

extern DFA   BuildDFA();
extern char *GetTerm();

#endif

#endif

